#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <unistd.h>

#include<pthread.h>


struct taskid{
  int myid;
  pthread_mutex_t start_lock;
  char *msg;
};

typedef struct taskid taskid_t;

void * 
concreader(void *arg)
{
  taskid_t tid = *(taskid_t *) arg;
  int i;
  int fd;
  char c;

  printf("%d:This is an example of concurrent use I/O. Notice I'll sleep until a rendez-vous occurs", tid.myid);
  printf("%d:I hope you will carefully read my sources before accusing any C implementation of any mistake",tid.myid);

  pthread_mutex_lock(&tid.start_lock);

  fd = open(tid.msg,O_RDONLY);

  while (read(fd,&c,1) == 1)
    write(STDOUT_FILENO,&c,1);

  close(fd);

  for (i=0;i<100000;i++){
      printf("%d:%d\n",tid.myid, i);
      printf("%d%s\n",tid.myid,"=> And Remember: C should not be blamed for your mistakes");
      printf("%d%s\n",tid.myid,"=> And indeed no compiler should be blamed for programmer's misconceptions");
  }
  return 0;
}


int
main(int argc, char *argv[]){
  int n;
  int i;
  taskid_t * taskid;
  pthread_t *tid;

  if (argc<2)
    exit(1);

  n=argc-1;
  taskid = (taskid_t *) malloc(n*sizeof(taskid_t));
  tid = (pthread_t *) malloc(n*sizeof(pthread_t));

  for (i=0;i<n;i++){
    taskid[i].myid=i;
/*     taskid[i].start_lock=PTHREAD_MUTEX_INITIALIZER; */
    pthread_mutex_init(&taskid[i].start_lock,0);
    pthread_mutex_lock(&taskid[i].start_lock);
    if (pthread_create(tid+i,0,concreader,taskid+i)>0)
      exit(1);
  }

  for(i=0;i<n;i++){
    taskid[i].msg=argv[i+1];
    pthread_mutex_unlock(&taskid[i].start_lock);
  }

      
  for(i=0;i<n;i++)
    pthread_join(tid[i],0);

  return 0;
}

  
